package jhttpd2019;

import java.net.*;
import java.io.*;
import java.util.HashMap;

/**
 * Description of the Class
 *
 * @author micha
 * @created 2009-01-30
 */
public class JHttpd {

    ServerSocket serverSocket = null;
    String getRequest;
    String zeile;
    String angefragteDatei;
    String queryString;
    String method;

    JHttpd(int port) {
        try {
            serverSocket = new ServerSocket(port);
        } catch (Exception e) {
            e.printStackTrace();
        }
        while (true) {
            try {

                // sobald eine anfrage zum server gelangt,
                // baut dieser eine tcp-verbindung auf:
                Socket clientSocket = serverSocket.accept();
                // tcp-kommunikationskanaele stellen einen byte-strom
                // zur verfuegung aus dem gelesen oder in den
                // geschrieben werden kann:
                BufferedReader in
                        = new BufferedReader(
                                new InputStreamReader(
                                        clientSocket.getInputStream()));
                PrintWriter out
                        = new PrintWriter(clientSocket.getOutputStream());
                //jetzt koennen wir den http-request beantworten:
                //zuerst ein paar formalitaeten:
                out.print("HTTP/1.0 200 \n");
                out.print("Content-Type: text/html \n");
                out.print("\n");

                getRequest = in.readLine();
                System.out.println("das ist der request: " + getRequest);
                System.out.println("und hier folgen die restlichen header-zeilen:");

                //nun lesen wir die restlichen zeilen des http-requests
                HashMap<String, String> hashMap = new HashMap<String, String>();
                int contentLength = 0;

                while (true) {
                    zeile = in.readLine();
                    System.out.println(zeile);
                    
                    if(zeile.length() == 0 && contentLength>0){
                        //char-buffer der laenge contentLength erzeugen
                        char[] postQueryBuf = new char[contentLength];
                        //genau contentLength bytes einlesen
                        in.read(postQueryBuf, 0, contentLength);
                        //aus char-buffer wird ein String erzeugt
                        queryString = new String(postQueryBuf);
                        System.out.println("postQueryString: "+queryString);
                        break;
                    }
                    
                    if (zeile.length() == 0) {
                        break;
                    }
                   
                    //wir suchen die header-zeile Content-Length: n
                    //und wandeln n in einen integer-wert
                    String[] headerZeile = zeile.split(":");
                    if(headerZeile[0].equals("Content-Length")){
                        contentLength=
                                Integer.parseInt(headerZeile[1].trim());
                    }

                }//while

                this.bearbeiteGetRequest();

                //jetzt koennen wir die angefragte datei oeffnen:
                if (!angefragteDatei.equals("favicon.ico")) {
                    System.out.println("die angefragte Datei heisst: " + angefragteDatei);
                    System.out.println("der QUERY_STRING heisst: " + queryString);

                    BufferedReader htmlDatei = new BufferedReader(
                            new FileReader(angefragteDatei));
//                  new FileReader( "index.html" ) );

                    while ((zeile = htmlDatei.readLine()) != null) {
                        System.out.println(zeile);
                        out.println(zeile);
                    }
                }

//                out.println("<hr/><hr/>");
//                out.println("die eingelesene datei heisst: " + angefragteDatei);
//                out.println("<br/> der queryString heisst: " + queryString);
//                out.println("<br/><hr/>");
//                out.print("<br/>JHttpd, 2019");
                //jetzt koennen wir alle verbindungen wieder abbauen:
                out.close();
                in.close();
                clientSocket.close();
                //htmlDatei.close();
            }//try
            catch (Exception e) {
                e.printStackTrace();

            }//block in der endlosschleife
        }
    }

    private void bearbeiteGetRequest() {
        String[] stringArray = new String[3];
        stringArray = getRequest.split(" ");

        String angefragteDateiMitQueryString = stringArray[1].substring(1);

        stringArray = new String[2];

        stringArray = angefragteDateiMitQueryString.split("\\?");

        angefragteDatei = stringArray[0];

        if (stringArray.length > 1) {
            queryString = stringArray[1];
        }
    }

    /**
     * The main program for the UDPSend class
     *
     * @param args The command line arguments
     */
    public static void main(String[] args) {
        if (args.length != 1) {
            System.out.println("Aufruf (im dist-verzeichnis): java -jar jhttpd.jar <port>");
        } else {
            int port = Integer.parseInt(args[0]);
            new JHttpd(port);
        }
    }
}
